<?php
$api_version = 1;

add_filter( 'upload_mimes', 'my_myme_types', 1, 1 );
function my_myme_types( $mime_types ) {
  $mime_types['svg'] = 'image/svg+xml';     // Adding .svg extension
  return $mime_types;
}

function wra_connect($forced = 0)
{	
	if (wra_check_connection()!=1)
		return false;

	$wra_state = get_option('wra_state');
	if ($wra_state == 'on') {
		$ip = get_option('wra_ip');
		$port = get_option('wra_port');
		$API_KEY = get_option('wra_api_key');
		$api_connection = get_option('wra_connect');
		$tokenId = get_option('wra_tokenId');
		$token = get_option('wra_token');
		$mac = get_option('wra_mac');

		$con = new pejvakApi($API_KEY, $ip, $port);

		if (!$api_connection || !$tokenId || $forced) {
			$getToket = $con->getToket();
			
			if(!$getToket) wra_disconnect();

			$tokenId = $getToket['tokenId'];
			$token = $getToket['token'];
			$mac = $getToket['mac'];
			update_option('wra_tokenId', $tokenId);
			update_option('wra_token', $token);
			update_option('wra_mac', $mac);
			update_option('wra_connect', 1);
			update_option('wra_connect_msg', $getToket['resMsg']);
		}
		return $con;
	} 
	else
	{
	    return null;
	}
}

function wra_disconnect()
{
	update_option('wra_tokenId', 0);
	update_option('wra_token', '');
	update_option('wra_mac', '');
	update_option('wra_connect', 0);
}

//Api Functions/////////////////////////////////////////////////////////////////////////////////////////////////////////

function wra_check_connection()
{
	$ip = get_option('wra_ip');
	$port = get_option('wra_port');
	$API_KEY = get_option('wra_api_key');
	$con = new pejvakApi($API_KEY, $ip, $port);
	$url = get_option('wra_ip');
	if ($port)
		$url .= ':' . $port;
	// $state = $con->wra_check_connection($url);
	// update_option('wra_connect', $state);

	$result = $con->wra_check_connection($url);
	update_option('wra_connect', $result['state']);

	$insertTime = date('Y-m-d H:i:s', current_time('timestamp'));
	$address = $url.'/WebApiService/api/v1/TimeStamp/ConnectToDatabase';
	global $wra_http_status;
	wra_add_report('GetTimeStamp', $insertTime, $address, '', json_encode($result['data']),$wra_http_status);

	return $result['state'];
}



function wra_get_product_groups()
{
	//$insertTime = date('Y-m-d H:i:s', current_time('timestamp'));
	$tokenId = get_option('wra_tokenId');
	$mac = get_option('wra_mac');

	$con = wra_connect();
    	if ($con && $tokenId) {
    		$GetProductGroups = $con->GetProductGroups($mac, $tokenId);
    
    		if (!wra_check_token($GetProductGroups)) {
    			$tokenId = get_option('wra_tokenId');
    			$mac = get_option('wra_mac');
    			$GetProductGroups = $con->GetProductGroups($mac, $tokenId);
    		}

        	//$url = get_option('wra_ip');
        	//$port = get_option('wra_port');
            //if ($port && $port!=80)$url .= ':' . $port;
    		//$address = $url.'/WebApiService/api/v1/product/GetProductGroups?mac=' . $mac . '&tokenId=' . $tokenId;
            //global $wra_http_status;
    		//wra_add_report('GetProductGroups', $insertTime, $address, '', json_encode($GetProductGroups),$wra_http_status);
    
    		return $GetProductGroups;
    	}

    return null;
    
}

function wra_get_products_simple()
{
	$tokenId = get_option('wra_tokenId');
	$mac = get_option('wra_mac');
	$con = wra_connect();
	if ($con && $tokenId) {
		$insertTime = date('Y-md H:i:s');
		$GetProductsSimpleDetail = $con->GetProductsSimpleDetail($mac, $tokenId);
		if (!wra_check_token($GetProductsSimpleDetail)) {
			$tokenId = get_option('wra_tokenId');
			$mac = get_option('wra_mac');
			$GetProductsSimpleDetail = $con->GetProductsSimpleDetail($mac, $tokenId);
		}
		return $GetProductsSimpleDetail;
	}
	return null;
}
function wra_get_products()
{
	//$insertTime = date('Y-m-d H:i:s', current_time('timestamp'));
	$tokenId = get_option('wra_tokenId'); 
	$mac = get_option('wra_mac');
	
	$con = wra_connect(); 

	if ($con && $tokenId) {
		$updates_count = get_option('wra_updates');
		$updates_page = get_option('wra_last_updates') ? get_option('wra_last_updates') : 1;
		$GetProducts = $con->GetProducts($mac, $tokenId, $updates_page, $updates_count);

		if (!wra_check_token($GetProducts)) {
			$tokenId = get_option('wra_tokenId');
			$mac = get_option('wra_mac');
			$GetProducts = $con->GetProducts($mac, $tokenId, $updates_page, $updates_count);
		}
 
		if (isset($GetProducts->paging) && ((($GetProducts->paging->totalItems) / $updates_count)) > $updates_page) {
			update_option('wra_last_updates', intval($updates_page) + 1);
		} else {
			update_option('wra_last_updates', 1);
		}


    	//$url = get_option('wra_ip');
    	//$port = get_option('wra_port');
        //if ($port && $port!=80)$url .= ':' . $port;
		//$address = $url.'/WebApiService/api/v1/product/GetProducts?mac=' . $mac . '&tokenId=' . $tokenId . '&pageNumber=' . $updates_page . '&recordsPerPage=' . $updates_count;
		// global $wra_http_status;
		//wra_add_report('GetProducts', $insertTime, $address, '', json_encode($GetProducts),$wra_http_status);
	
		return $GetProducts;
	}
		return null;
}

function wra_get_product($productId)
{
	

	//$insertTime = date('Y-m-d H:i:s', current_time('timestamp'));
	global $wpdb;
	$query = "SELECT * FROM {$wpdb->base_prefix}wra_products_map where productId=" . $productId;

	$result = $wpdb->get_results($query);
	if (sizeof($result)) {
		$tokenId = get_option('wra_tokenId');
		$token = get_option('wra_token');

		$con = wra_connect();
		if ($con && $tokenId) {
			$mac = $con->encrypt_data(
				md5(
					json_encode(
						array(
							"tokenId" => intval($tokenId),
							"productId" => intval($result[0]->apiProductId)
						)
					)
				),
				$token
			);
			$GetProducts = $con->GetProduct($mac, $tokenId, $result[0]->apiProductId);
			
			if (!wra_check_token($GetProducts)) {
				$tokenId = get_option('wra_tokenId');
				$token = get_option('wra_token');
				$mac = $con->encrypt_data(
					md5(
						json_encode(
							array(
								"tokenId" => intval($tokenId),
								"productId" => intval($result[0]->apiProductId)
							)
						)
					),
					$token
				);
				$GetProducts = $con->GetProduct($mac, $tokenId, $result[0]->apiProductId);
			}
//
        	// $url = get_option('wra_ip');
        	// $port = get_option('wra_port');
            // if ($port && $port!=80)$url .= ':' . $port;
    		// $address = $url.'/WebApiService/api/v1/product/GetProductById/' . $mac . '/' . $tokenId . '/' . $productId;
			//  global $wra_http_status;
			// wra_add_report('GetProduct', $insertTime, $address, '', json_encode($GetProducts),$wra_http_status);

			return $GetProducts;
		}
	}
	return null;
}


function wra_send_factor($order_id, $data)
{
	//$insertTime = date('Y-m-d H:i:s', current_time('timestamp'));
	global $wpdb;
	$GetProducts = null;
	$tokenId = get_option('wra_tokenId');
	$token = get_option('wra_token');
	$con = wra_connect();
	$data['TokenId'] = intval($tokenId);

	if ($tokenId) {
		$ip = get_option('wra_ip');
		$port = get_option('wra_port');
		$API_KEY = get_option('wra_api_key');
		$mac = get_option('wra_mac');
		$con1 = new pejvakApi($API_KEY, $ip, $port);
		if ($con1) {
			$FactorNew = json_encode($data);
			
			$mac = $con1->encrypt_data(md5($FactorNew), $token);
			$data['Mac'] = $mac;
			$FactorNew = json_encode($data);

			$queue_id = wra_add_queue('/WebApiService/api/v1/Factor/FactorAdd', $FactorNew, 'POST');

			if ($con) {
				$GetProducts = $con->sendFactor($FactorNew,$queue_id);
				if (!wra_check_token($GetProducts)) {
					$tokenId = get_option('wra_tokenId');
					$token = get_option('wra_token');
					$data['TokenId'] = intval($tokenId);					
					unset($data['Mac']);
					$FactorNew = json_encode($data);
					$mac = $con->encrypt_data(md5($FactorNew), $token);
					$data['Mac'] = $mac;
					$FactorNew = json_encode($data);
					$GetProducts = $con->sendFactor($FactorNew,$queue_id);
				}

				// 	$url = get_option('wra_ip');
				// 	$port = get_option('wra_port');
				//     if ($port && $port!=80)$url .= ':' . $port;
				// 	$address = $url.'/WebApiService/api/v1/Factor/FactorAdd';

				global $wra_http_status;
				// wra_add_report('FactorAdd', $insertTime, $address, json_encode($FactorNew), json_encode($GetProducts),$wra_http_status);
				if ($GetProducts && $wra_http_status == 200 && $GetProducts->res>=0)
					wra_update_state_queue($queue_id, 1);
				return $GetProducts;
			}

		}
	}
	return null;
}


////////////////queue///////////////////////
function wra_add_queue($url, $data = '', $method = 'POST')
{
	global $wpdb;
	wra_check_queue_table_exist();
	$table = "wra_queue";
	$table_name = $wpdb->base_prefix . $table;
	$created_at = date('Y-m-d H:i:s', current_time('timestamp'));

	$data=json_encode(json_decode($data),JSON_UNESCAPED_UNICODE);
	
	$sql = "INSERT INTO {$table_name} (url,data,method,status,created_at) 
			VALUES ('{$url}','{$data}','{$method}',0,'{$created_at}')";
	$wpdb->query($sql);
	return $wpdb->insert_id;
}
function wra_get_queues()
{
	wra_check_queue_table_exist();
	global $wpdb;
	$table = "wra_queue";
	$table_name = $wpdb->base_prefix . $table;
	$query = "SELECT * FROM {$table_name} where status=0 order by id asc";
	return $wpdb->get_results($query);
}
function wra_update_state_queue($id, $status)
{
	wra_check_queue_table_exist();
	global $wpdb;
	$table = "wra_queue";
	$table_name = $wpdb->base_prefix . $table;
	$date = date('Y-m-d H:i:s', current_time('timestamp'));
	if($status)
		$sql = "UPDATE {$table_name} set status = {$status}, retry = retry + 1 , send_at = '{$date}' WHERE id = {$id}";
	else
	    $sql = "UPDATE {$table_name} set status = {$status}, retry = retry + 1 WHERE id = {$id}";
	return $wpdb->query($sql);
}
function wra_delete_queue($id)
{
	global $wpdb;
	$table = "wra_queue";
	$table_name = $wpdb->base_prefix . $table;
	$sql = "UPDATE {$table_name} SET status = -2 WHERE status = 0 and data like '%\"FactorNumber\":\"{$id}\"%'";
	return $wpdb->query($sql);
}


function wra_get_queue_count()
{
	wra_check_queue_table_exist();
	global $wpdb;
	$table = "wra_queue";
	$table_name = $wpdb->base_prefix . $table;
	$query = "SELECT count(*) as counts FROM {$table_name} where status=0";
	$result = $wpdb->get_results($query);
	if ($result)
		return $result[0]->counts;
	else
		return 0;
}

function wra_send_queue()
{
	$msg='';


	$ip = get_option('wra_ip');
	$port = get_option('wra_port');
	$API_KEY = get_option('wra_api_key');
	$con = new pejvakApi($API_KEY, $ip, $port);
	$token = get_option('wra_token');
	$id = 0;


	if(!wra_connect())$msg = 'عدم ارتباط با وب سرویس<br>';

	$queues = wra_get_queues();
	$send_factor = get_option('wra_send_factor');
	if ($queues && $send_factor=='on')
		foreach ($queues as $item) {

			$data = json_decode($item->data);

			if(!isset($data->Factor))
			{
				global $wpdb;
				$table = "wra_queue";
				$table_name = $wpdb->base_prefix . $table;
				$sql = "DELETE FROM {$table_name} WHERE id=".$item->id;
				$wpdb->query($sql);
				continue;
			}
			
			$tokenId = get_option('wra_tokenId');
			$token = get_option('wra_token');

			$data->TokenId = intval($tokenId);				
			unset($data->Mac);
			$FactorNew = json_encode($data);
			$mac = $con->encrypt_data(md5($FactorNew), $token);
			$data->Mac = $mac;
			$FactorNew = json_encode($data);


			$result_data = $con->get($item->url, $FactorNew, $item->method);
			$result = json_decode($result_data);
			global $wra_http_status;
			if ($result && $wra_http_status==200 && $result->res>=0) {
				wra_update_state_queue($item->id, 1);
			}
			else
			{
				if($msg)
					$msg.= $result->resMsg.'<br>';
				wra_update_state_queue($item->id, 0);
			}

        	$url = get_option('wra_ip');
        	$port = get_option('wra_port');
            if ($port && $port!=80)$url .= ':' . $port;
    		$address = $url.'/WebApiService/api/v1/Factor/FactorAdd';
			
			$insertTime = date('Y-m-d H:i:s', current_time('timestamp'));
		 
			wra_add_report('FactorAdd', $insertTime, $address, $item->data, $result_data,$wra_http_status, $item->id);


		}
	return $msg;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////

function wra_update_product_groups()
{
	global $wpdb;
	wra_check_groups_table_exist();
	$groups = wra_get_product_groups();
	$insertTime = date('Y-m-d H:i:s', current_time('timestamp'));

	if ($groups) {
		if(!empty($groups->productGroups)){
			foreach ($groups->productGroups as $group) {
				$check_row = $wpdb->get_results("SELECT group_id FROM {$wpdb->base_prefix}wra_groups WHERE (group_id = {$group->id})");
				if ($check_row && sizeof($check_row)) {
					$data = [
						'title' => $group->title,
						'groupParentID' => $group->groupParentID
					];
					wra_update_multiple_row($wpdb->base_prefix . 'wra_groups', $data, 'group_id=' . $group->id);
					
					if(get_option('wra_save_action_logs')=='on')
						wra_add_report('updateGroup', $insertTime, '', json_encode($data), "", 200, 0, "گروه بروزرسانی شد.");


				} else {
					$data = [
						[
							'group_id' => $group->id,
							'title' => $group->title,
							'groupParentID' => $group->groupParentID,
							'siteGroupId' => 0,
						]
					];
					wra_insert_multiple_rows($wpdb->base_prefix . 'wra_groups', $data);

					if(get_option('wra_save_action_logs')=='on')
						wra_add_report('addGroup', $insertTime, '', json_encode($data), "", 200, 0, "گروه اضافه شد.");


				}

			}
		}
		return true;

	} else {
		return false;
	}
}
function wra_update_products()
{
	global $wpdb;
	$products = wra_get_products();

	wra_check_products_map_table_exist();
	if($products)
	{
		if(isset($products->paging->totalItems))
		{
			$product_total=$products->paging->totalItems;
			update_option('wra_total_products',$product_total);
			$product_from = ($products->paging->currentPage-1)*$products->paging->itemsPerPage+1;
			update_option('wra_from_product',$product_from);
			$product_to = ($products->paging->currentPage-1)*$products->paging->itemsPerPage+$products->paging->itemsPerPage;
			if(intval($product_to)>intval($product_total))$product_to=$product_total;
			update_option('wra_to_product',$product_to);
		}

		if (!empty($products->products)) {
			foreach ($products->products as $product) {


				if($product->productImage && get_option('wra_update_images')=='on')
					$image = wra_get_image($product->productImage);
				else
					$image = 0;
				
				

				$product_data = array(
					'productId' => $product->productID,
					'productUnitID' => $product->productUnitID,
					'name' => $product->productName,
					'slug' => sanitize_title($product->productName),
					'status' => $product->productIsDisabled ? 'pending' : 'publish',
					'description' => $product->productDescription,
					'sku' => $product->productCode,
					'price' => $product->productFinalPrice,
					'regular_price' => $product->productSalePrice,
					'sale_price' => $product->productFinalPrice,
					'manage_stock' => 1,
					'stock_quantity' => $product->productAmount,
					'stock_status' => 'instock',
					'image_id' => $image,
					'productGroups' => $product->productGroups

				);
		

				$productObj = new Wra_Product_class();


				global $wpdb;
				$productId = $wpdb->get_var($wpdb->prepare("SELECT post_id FROM $wpdb->postmeta WHERE meta_key='_sku' AND meta_value='%s' LIMIT 1", $product->productCode));
		


				$productId = 0;
				$sql = "SELECT productId FROM {$wpdb->base_prefix}wra_products_map WHERE productCode={$product->productCode}  LIMIT 1";
				
				$data = $wpdb->get_results($sql);



				if($data)
				{
					$productId = $data[0]->productId;
					
					if($productId)
					{
						$sql = "SELECT ID FROM {$wpdb->base_prefix}posts WHERE ID={$productId} LIMIT 1";
						$data = $wpdb->get_results($sql);
						if(!$data){		//echo ($productId).'==';		
							$sql = "DELETE FROM {$wpdb->base_prefix}wra_products_map WHERE productId={$productId}";
							$wpdb->query($sql);							
							//$productId = 0;
						}
					}
				

					//$productId = $wpdb->get_var($wpdb->prepare("SELECT post_id FROM $wpdb->postmeta WHERE post_id='%s' LIMIT 1", $productId));
				}
				else
				{
				    $productId = $wpdb->get_var($wpdb->prepare("SELECT post_id FROM $wpdb->postmeta WHERE meta_key='_sku' AND meta_value='%s' LIMIT 1", $product->productCode));
				    $productId = $wpdb->get_var($wpdb->prepare("SELECT ID FROM $wpdb->post WHERE ID='%s'  LIMIT 1", $productId));

				}

				  

				$insertTime = date('Y-m-d H:i:s', current_time('timestamp'));


			

				//$productId = $productObj -> wc_get_product_id_by_sku($product->productCode);
				if ($productId)
				{
				  
					$productObj->update_product($productId, $product_data);
					if(get_option('wra_save_action_logs')=='on')
						wra_add_report('updateProduct', $insertTime, '', json_encode($product_data), "", 200, 0, "محصول بروزرسانی شد.");
				}
				else
				{   
				   
					
					$productObj->add_product($product_data);
					if(get_option('wra_save_action_logs')=='on')
						wra_add_report('addProduct', $insertTime, '', json_encode($product_data), "", 200, 0, "محصول اضافه شد.");
				}
		

			}

		} 
		return true;
	}
	else{
		return false;
	}

}
function wra_update_products_simple()
{

}

function wra_cron_job()
{
	update_option('wra_connect_msg', '');
	$result = '';
	$result.=wra_send_queue();
	if(!wra_update_product_groups())
		$result.='خطا در دریافت دسته بندی <br>'; 
	if(!wra_update_products())
		$result.=' خطا در دریافت محصولات <br>';

	$connection_msg = get_option('wra_connect_msg');
	if($connection_msg && $connection_msg!='بدون خطا')
		$result=$connection_msg.'<br>'.$result;

	return $result;
}

function wra_check_token($data)
{

	if (isset($data->res) && $data->res != 0) {

		if ($data->res == -9 || $data->res == -10)
			{
				wra_connect(1);
				return false;
			}
		else {
			wra_notice($data->resMsg, 'error');
		}		
	} 
	return true;
}

function wra_add_report($action, $insertTime = '', $address = '', $json = '', $response = '', $wra_http_status=200, $queue_id=0, $description='')
{
	
	global $wpdb;
	$table = "wra_reports";
	$table_name = $wpdb->base_prefix . $table;
	wra_check_reports_table_exist();
	$updateTime = date('Y-m-d H:i:s', current_time('timestamp'));
	$json=str_replace('\'','',$json);
	$response=str_replace('\'','',$response);

	if($response)
	{
		$resp=json_decode($response);
		if(isset($resp->resMsg))$description=$resp->resMsg;
	}

	if($json)
		$json=json_encode(json_decode($json),JSON_UNESCAPED_UNICODE);
	
	$sql = "INSERT INTO {$table_name} (action,insertTime,updateTime,address,json,response,status,description,queue_id) 
			VALUES ('{$action}','{$insertTime}','{$updateTime}','{$address}','{$json}','{$response}','{$wra_http_status}','{$description}',{$queue_id})";

	$wpdb->query($sql);

}


//Database Functions/////////////////////////////////////////////////////////////////////////////////////////////////////////
function wra_check_groups_table_exist()
{
	$table = "wra_groups";
	global $wpdb;
	$table_name = $wpdb->base_prefix . $table;
	$query = $wpdb->prepare('SHOW TABLES LIKE %s', $wpdb->esc_like($table_name));

	if (!$wpdb->get_var($query) == $table_name) {

		$charset_collate = $wpdb->get_charset_collate();
		$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->base_prefix}{$table}` (
		  `id` int(11) NOT NULL AUTO_INCREMENT,
			`group_id` bigint(20) NOT NULL,
			`title` varchar(255) NOT NULL,
			`groupParentID` bigint(20) NOT NULL,
			`siteGroupId` bigint(20) NOT NULL,
			PRIMARY KEY (id)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
			";

		require_once ABSPATH . 'wp-admin/includes/upgrade.php';
		dbDelta($sql);
		$is_error = empty($wpdb->last_error);
	}
}
function wra_check_reports_table_exist()
{

	$table = "wra_reports";
	global $wpdb;
	$table_name = $wpdb->base_prefix . $table;
	$query = $wpdb->prepare('SHOW TABLES LIKE %s', $wpdb->esc_like($table_name));

	if (!$wpdb->get_var($query) == $table_name) {

		$charset_collate = $wpdb->get_charset_collate();
		$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->base_prefix}{$table}` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`queue_id` INT NOT NULL DEFAULT '0',
			`description` varchar(1000) NOT NULL,
			`action` varchar(255) NOT NULL,
			`insertTime` datetime NOT NULL,
			`updateTime` datetime NOT NULL DEFAULT current_timestamp(),
			`address` varchar(255) NOT NULL,
			`json` longtext NOT NULL,
			`response` longtext NOT NULL,	
			`status` varchar(20) NOT NULL,	
			PRIMARY KEY (id)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
			";

		require_once ABSPATH . 'wp-admin/includes/upgrade.php';
		dbDelta($sql);
		$is_error = empty($wpdb->last_error);
	}
}

function wra_check_queue_table_exist()
{
	$table = "wra_queue";
	global $wpdb;
	$table_name = $wpdb->base_prefix . $table;
	$query = $wpdb->prepare('SHOW TABLES LIKE %s', $wpdb->esc_like($table_name));

	if (!$wpdb->get_var($query) == $table_name) {

		$charset_collate = $wpdb->get_charset_collate();
		$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->base_prefix}{$table}` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`url` varchar(255) NOT NULL,
			`method` varchar(10) NOT NULL,
			`data` longtext NOT NULL,
			`retry` int(11) NOT NULL DEFAULT '0',
			`status` int(11) NOT NULL,
			`created_at` datetime NOT NULL,
			`send_at` datetime NOT NULL,
			PRIMARY KEY (id)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
			";

		require_once ABSPATH . 'wp-admin/includes/upgrade.php';
		dbDelta($sql);
		$is_error = empty($wpdb->last_error);
	}
}

function wra_check_products_map_table_exist()
{
	$table = "wra_products_map";
	global $wpdb;
	$table_name = $wpdb->base_prefix . $table;
	$query = $wpdb->prepare('SHOW TABLES LIKE %s', $wpdb->esc_like($table_name));

	if (!$wpdb->get_var($query) == $table_name) {

		$charset_collate = $wpdb->get_charset_collate();
		$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->base_prefix}{$table}` (
			`id` int(11) NOT NULL AUTO_INCREMENT,
			`productId` int(11) NOT NULL,
  			`apiProductId` int(11) NOT NULL,
  			`ProductCnuId` int(11) NOT NULL,	
			`productCode` VARCHAR(255) NULL DEFAULT '',				
			PRIMARY KEY (id)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
			";

		require_once ABSPATH . 'wp-admin/includes/upgrade.php';
		dbDelta($sql);
		$is_error = empty($wpdb->last_error);
	}
	else
	{
            $wpdb->query( "ALTER TABLE `".$table_name."` ADD `productCode` VARCHAR(255) NULL DEFAULT '' " );
	}

	
}


function wra_insert_multiple_rows($table, $request)
{
	global $wpdb;
	$column_keys = '';
	$column_values = '';
	$sql = '';
	$last_key = array_key_last($request);
	$first_key = array_key_first($request);
	foreach ($request as $k => $value) {
		$keys = array_keys($value);

		// Prepare column keys & values.
		foreach ($keys as $v) {
			$column_keys .= sanitize_key($v) . ',';
			$sanitize_value = sanitize_text_field($value[$v]);
			$column_values .= is_numeric($sanitize_value) ? $sanitize_value . ',' : "'$sanitize_value'" . ',';
		}
		// Trim trailing comma.
		$column_keys = rtrim($column_keys, ',');
		$column_values = rtrim($column_values, ',');
		if ($first_key === $k) {
			$sql .= "INSERT INTO {$table} ($column_keys) VALUES ($column_values)";
		} elseif ($last_key == $k) {
			$sql .= "($column_values)";
		} else {
			$sql .= ",($column_values)";
		}

		// Reset keys & values to avoid duplication.
		$column_keys = '';
		$column_values = '';
	}

	return $wpdb->query($sql);
}


function wra_update_multiple_row($table, $request, $where)
{
	global $wpdb;
	$columns = '';
	$sql = '';
	$i = 0;
	foreach ($request as $key => $v) {
		if ($i)
			$columns .= ',';
		$columns .= "{$key} = '{$v}' ";
		$i = 1;
	}
	$sql = "UPDATE {$table} set {$columns} WHERE {$where}";

	return $wpdb->query($sql);
}


function wra_get_image($base64_img)
{
    
    $title =time();

	// Upload dir.
	$upload_dir  = wp_upload_dir();
	$upload_path = str_replace( '/', DIRECTORY_SEPARATOR, $upload_dir['path'] ) . DIRECTORY_SEPARATOR;

	$img             = str_replace( 'data:image/jpeg;base64,', '', $base64_img );
	$img             = str_replace( ' ', '+', $img );
	$decoded         = base64_decode( $img );
	$filename        = $title . '.jpeg';
	$file_type       = 'image/jpeg';
	$hashed_filename = md5( $filename . microtime() ) . '_' . $filename;

	// Save the image in the uploads directory.
	$upload_file = file_put_contents( $upload_path . $hashed_filename, $decoded );

	$attachment = array(
		'post_mime_type' => $file_type,
		'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $hashed_filename ) ),
		'post_content'   => '',
		'post_status'    => 'inherit',
		'guid'           => $upload_dir['url'] . '/' . basename( $hashed_filename )
	);

	$attach_id = wp_insert_attachment( $attachment, $upload_dir['path'] . '/' . $hashed_filename );
	
	require_once(ABSPATH . 'wp-admin/includes/image.php');
	$attach_data = wp_generate_attachment_metadata($attach_id, $upload_dir['path'] . '/' . $hashed_filename);
	wp_update_attachment_metadata($attach_id, $attach_data);
	
	
    return $attach_id;
}



function wra_get_image_url($image_url)
{
	$upload_dir = wp_upload_dir();

	$image_data = file_get_contents($image_url);

	$filename = basename($image_url);

	if (wp_mkdir_p($upload_dir['path'])) {
		$file = $upload_dir['path'] . '/' . $filename;
	} else {
		$file = $upload_dir['basedir'] . '/' . $filename;
	}

	file_put_contents($file, $image_data);

	$wp_filetype = wp_check_filetype($filename, null);

	$attachment = array(
		'post_mime_type' => $wp_filetype['type'],
		'post_title' => sanitize_file_name($filename),
		'post_content' => '',
		'post_status' => 'inherit'
	);

	$attach_id = wp_insert_attachment($attachment, $file);
	require_once(ABSPATH . 'wp-admin/includes/image.php');
	$attach_data = wp_generate_attachment_metadata($attach_id, $file);
	wp_update_attachment_metadata($attach_id, $attach_data);
	return $attach_id;
}

function wra_fix_letter($word)
{
    $word = str_replace('ك','ک',$word);
    $word = str_replace('ي','ی',$word);
    return trim($word);
}

function wra_notice($message, $type)
{
	add_action('admin_notices', function () use ($message, $type) {
?>
<div class="notice notice-<?php echo $type; ?> is-dismissible">
	<p><?php echo $message ?></p>
</div>
<?php
	});


}

// function dd($data)
// {
// 	echo '<pre style="
// 	background-color: #efefef;
//     padding: 10px 15px;
//     overflow: auto;">';
// 	print_r($data);
// 	echo '</pre>';
// 	die;

// }