<?php
//add setting page to menu

if (!class_exists('WP_List_Table')) {
	require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
}

function wra_rest_api_groups_page_content()
{
	if (isset($_POST['assign-group-submit']) && isset($_POST['group'])) {
		global $wpdb;
		$table = $wpdb->base_prefix . 'wra_groups';

		foreach ($_POST['group'] as $key => $group) {
			$sql = "UPDATE {$table} set siteGroupId={$group} WHERE id=" . $key;
			$wpdb->query($sql);
		}
		wra_notice('تغییرات با موفقیت ذخیره شد.', 'success');
	}


?>
<div class="wrap">
	<h1>انتساب گروه ها</h1>
	<form method="post">
		<?php
	$wp_list_table = new Wra_Group_List_Table();
	$wp_list_table->prepare_items();
	$wp_list_table->display();
        ?>
	</form>
</div>
<?php
}


class Wra_Group_List_Table extends WP_List_Table
{
	public function __construct()
	{
		parent::__construct(
			array(
				'singular' => 'test',
				'plural' => 'tests',
				'ajax' => false
			)
		);
	}

	function extra_tablenav($which)
	{
		if ($which == "top") {
			echo "";
		}
		if ($which == "bottom") {
			echo "<button type='submit' name='assign-group-submit' class='button button-primary'>ذخیره تغییرات</button>";
		}
	}

	function get_columns()
	{
		$columns = array(
			'title' => 'نام',
			'groupParentID' => 'دسته بندی',
			'siteGroupId' => 'انتساب',
		);
		return $columns;
	}

	function get_sortable_columns()
	{
		return $sortable = array(
			'id' => array('id', false),
			'title' => array('title', false),
		);
	}


	function column_default($item, $column_name)
	{

		$args = array(
			'taxonomy' => "product_cat",
			'hide_empty' => 0,
		);
		$product_categories = get_terms($args);

		global $wpdb;
		$query = "SELECT * FROM {$wpdb->base_prefix}wra_groups";
		$product_categories_list = $wpdb->get_results($query);

		$parent = '---';
		if ($column_name == 'groupParentID' && $product_categories_list)
			foreach ($product_categories_list as $category)
				if ($category->group_id == $item[$column_name]) {
					$parent = $category->title;
				}

		$select_data = '';

		if ($column_name == 'siteGroupId' && $product_categories)
		{
			foreach ($product_categories as $category) {

			        
    				if ($category->term_id == $item['siteGroupId'])
    					$select_data .= "<option value='" . $category->term_id . "' selected>" . $category->name . "</option>";
					elseif(!$item[$column_name] && wra_fix_letter($category->name)==wra_fix_letter($item['title']))
						$select_data .= "<option value='" . $category->term_id . "' selected>" . $category->name . "</option>";    				
					else
    					$select_data .= "<option value='" . $category->term_id . "'>" . $category->name . "</option>";
			
    					
			}
		}
	


		switch ($column_name) {
			case 'id':
			case 'title':
				return $item[$column_name];
			case 'groupParentID':
				return $parent;
			case 'siteGroupId':
				return "<select name='group[" . $item['id'] . "]' class='form-control'>" . $select_data . "</select>";
			default:
				return print_r($item, true);
		}
	}

	function prepare_items()
	{
		global $wpdb;
		$query = "SELECT * FROM {$wpdb->base_prefix}wra_groups WHERE title not like 'گـروه كالا'";
		$orderby = !empty($_GET["orderby"]) ? $_GET["orderby"] : 'ASC';
		$order = !empty($_GET["order"]) ? $_GET["order"] : '';
		if (!empty($orderby) & !empty($order)) {
			$query .= ' ORDER BY ' . $orderby . ' ' . $order;
		}
		$totalitems = $wpdb->query($query);
		$perpage = 20;
		$paged = !empty($_GET["paged"]) ? intval($_GET["paged"]) : '';
		if (empty($paged) || !is_numeric($paged) || $paged <= 0) {
			$paged = 1;
		}
		$totalpages = ceil($totalitems / $perpage);
		if (!empty($paged) && !empty($perpage)) {
			$offset = ($paged - 1) * $perpage;
			$query .= ' LIMIT ' . (int) $offset . ',' . (int) $perpage;
		}
		$this->set_pagination_args(
			array(
				"total_items" => $totalitems,
				"total_pages" => $totalpages,
				"per_page" => $perpage,
			)
		);
		$columns = $this->get_columns();
		$hidden = array();
		$sortable = $this->get_sortable_columns();
		$this->_column_headers = array($columns, $hidden, $sortable);
		$items = $wpdb->get_results($query);
		if ($items)
			foreach ($items as &$item)
				$item = (array) $item;
		$this->items = (array) $items;
	}
}